module qsort_c_to_fortran
      use iso_c_binding
      integer, parameter :: sp = selected_real_kind(6)
      interface
        subroutine qsort(a,n,size_a,compare_fun)  bind(c)
           use iso_c_binding
           type(c_ptr), value :: a
           integer(c_size_t), value :: n
           integer(c_size_t), value :: size_a
           type(c_funptr), value :: compare_fun
        end subroutine qsort
      end interface
   contains
     subroutine qsort_wrapper_float(a, n)
        integer(c_int) :: n
        real(c_float), pointer :: a(:) 
        call qsort(c_loc(a(1)), int(n,c_size_t), c_sizeof(a(1)), c_funloc(compare_reals_wrapper));
     end subroutine qsort_wrapper_float
     integer(c_int) function compare_reals_wrapper(a,b) bind(c)
         real(c_float) :: a,b
         compare_reals_wrapper = compare_reals(a,b)
     end function compare_reals_wrapper
     integer function compare_reals(a,b) 
         real(sp) :: a,b
         if(a>b) then 
           compare_reals=1
         else if(a<b) then
           compare_reals=-1
         else
           compare_reals=0
         endif
     end function compare_reals
end module qsort_c_to_fortran

program test_qsort_c

use qsort_c_to_fortran

integer, parameter :: n=7
real(sp), pointer :: a(:) 

allocate(a(n))
call random_number(a)
print*,'Unordered a: '
print*,a

call qsort_wrapper_float(a, n);

print*,'Ordered a: '
print*,a

end program test_qsort_c
